︠baad439b-e0e6-4375-92b8-f10164c100e7s︠
from sage.ext.fast_eval import fast_float

var('x,y,z,a,b,c')
f = y^4 + 5*x^4 - 6*x^2*y^2 + 6*x^3*z + 26*x^2*y*z + 10*x*y^2*z - 10*y^3*z - 32*x^2*z^2 - 40*x*y*z^2 + 24*y^2*z^2 + 32*x*z^3 - 16*y*z^3
ff = fast_float(f,'x','y','z')

gradx = f.diff(x)
grady = f.diff(y)
gradz = f.diff(z)

gx_ff = fast_float(gradx, 'x', 'y', 'z')
gy_ff = fast_float(grady, 'x', 'y', 'z')
gz_ff = fast_float(gradz, 'x', 'y', 'z')
gmag = fast_float(sqrt(gradx^2+grady^2+gradz^2), 'x', 'y', 'z')

pos_sphere = sqrt(16-x^2-y^2)
pos_ff = fast_float(pos_sphere,'x','y')
︡dd7dd5bb-1eba-44de-a154-b5da03c516f9︡{"stdout":"(x, y, z, a, b, c)\n"}︡{"done":true}
︠b277ba52-5201-4c12-9b8f-72309b661a5cs︠

%time
N = 1000
R = 4
TOL = 1

# Carve up the xy plane into a (2N+1) x (2N+1) grid and try to find a z value of an intersectin at each lattice point
our_points = []
for i in range(-N,N+1):
    if not i%100:
        print i
    x0 = R*float(i)/N
    x_used = False
    recent_y = None
    for j in range(-N,N+1):
        y0 = R*float(j)/N
        # Compute the z value on the sphere
        pos_z = pos_ff(x0,y0)
        # Compute the function value and the gradient.
        # If the gradient suggests we can get to an actual solution without changing by more than the size of our lattice, do it.
        pos_val = ff(x0,y0,pos_z)
        pos_grad = gmag(x0,y0,pos_z)
        pos_ratio = pos_val/pos_grad
        if abs(N*pos_ratio) < R/2:
            # Since we're not too far off, adjust our point to lie on our surface better and consider it done.
            our_points.append((x0-pos_ratio*gx_ff(x0,y0,pos_z)/pos_grad, y0-pos_ratio*gy_ff(x0,y0,pos_z)/pos_grad, pos_z-pos_ratio*gz_ff(x0,y0,pos_z)/pos_grad))
        # Negatives now!
        neg_z = -pos_z
        neg_val = ff(x0,y0,neg_z)
        neg_grad = gmag(x0,y0,neg_z)
        neg_ratio = neg_val/neg_grad
        if abs(N*neg_ratio) < R/2:
            our_points.append((x0-neg_ratio*gx_ff(x0,y0,neg_z)/neg_grad, y0-neg_ratio*gy_ff(x0,y0,neg_z)/neg_grad, neg_z-neg_ratio*gz_ff(x0,y0,neg_z)/neg_grad))

print len(our_points)
︡9c67f050-4161-4f36-b066-6667469720d5︡{"stdout":"-1000\n-900"}︡{"stdout":"\n-800"}︡{"stdout":"\n-700"}︡{"stdout":"\n-600"}︡{"stdout":"\n-500"}︡{"stdout":"\n-400"}︡{"stdout":"\n-300"}︡{"stdout":"\n-200"}︡{"stdout":"\n-100"}︡{"stdout":"\n0"}︡{"stdout":"\n100"}︡{"stdout":"\n200"}︡{"stdout":"\n300"}︡{"stdout":"\n400"}︡{"stdout":"\n500"}︡{"stdout":"\n600"}︡{"stdout":"\n700"}︡{"stdout":"\n800"}︡{"stdout":"\n900"}︡{"stdout":"\n1000"}︡{"stdout":"\n"}︡{"stdout":"7102\n"}︡{"stdout":"\nCPU time: 131.62 s, Wall time: 139.19 s\n"}︡{"done":true}
︠185f4ecb-010a-474c-8926-d5b4c3edfc6es︠
euclidean_distance = fast_float(sqrt((x-a)^2+(y-b)^2+(z-c)^2),'x','y','z','a','b','c') # There's probably something built in, but this'll do

# Now we attempt to put the points in neighborly order

MAX_DIST = 2
points_copy = our_points[:]
neighbors = [[points_copy.pop(3000)]] # Start with not the first point in case the corner is weird
counter = 0
while points_copy:
    if not counter%1000:
        print counter
    counter += 1
    cur_point = neighbors[-1][-1]
     # Find the nearest point of the remaining ones
    nn = min(range(len(points_copy)), key=lambda i: euclidean_distance(*(points_copy[i]+cur_point)))
    dist = euclidean_distance(*(points_copy[nn]+cur_point))
    if dist < MAX_DIST:
        # If it's not out of range, let's use it
        neighbors[-1].append(points_copy.pop(nn))
    else:
        # Otherwise, check if it should loop...
        if euclidean_distance(*(neighbors[-1][-1] + neighbors[-1][0])) < MAX_DIST:
            neighbors[-1].append(neighbors[-1][0])
        # ...and regardless start a new chain
        neighbors.append([points_copy.pop(nn)])
# Final loop check
if euclidean_distance(*(neighbors[-1][-1] + neighbors[-1][0])) < MAX_DIST:
    neighbors[-1].append(neighbors[-1][0])

print len(neighbors), [len(block) for block in neighbors]
︡d9c8856c-4c6e-446e-ba98-1dc23efb5391︡{"stdout":"0\n1000"}︡{"stdout":"\n2000"}︡{"stdout":"\n3000"}︡{"stdout":"\n4000"}︡{"stdout":"\n5000"}︡{"stdout":"\n6000"}︡{"stdout":"\n7000"}︡{"stdout":"\n"}︡{"stdout":"2 [3552, 3552]\n"}︡{"done":true}
︠1333495a-685b-42f8-9974-e8bc4f43f956s︠

A = implicit_plot3d(f==0, (x,-4,4), (y,-4,4), (z,-4,4), plot_points=100, frame=false, opacity=.5) #Plot the surface
C = implicit_plot3d(x^2+y^2+z^2==16, (x,-4,4), (y,-4,4), (z,-4,4), plot_points=80, frame=false, color="seashell", opacity=.2)

the_visualization= sum((line(block, color="black") for block in neighbors), A+C) #Plot blocks of neighbors

show(the_visualization.rotate((-1,-1,3),-5*pi/12).scale(2))

︡fd87ca1c-5ab7-427f-a28e-fab8ff41438e︡{"stderr":"Error in lines 1-1\n"}︡{"stderr":"Traceback (most recent call last):\n  File \"/cocalc/lib/python3.9/site-packages/smc_sagews/sage_server.py\", line 1230, in execute\n    exec(\n  File \"\", line 1, in <module>\nNameError: name 'f' is not defined\n"}︡{"done":true}
︠8de12775-cf8b-46b0-ba46-be7f7f9d233fs︠









